=== debian/changelog ===
nheko (0.0+git20171116.21fdb26-2) unstable; urgency=medium

  * Don't use -march=native. (Closes: #882206)
  * Make build more verbose.

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 23 Nov 2017 14:21:25 -0500

nheko (0.0+git20171116.21fdb26-1) unstable; urgency=medium

  * New upstream version.
  * Update build-dependency for Qt5LinguistTools. (Closes: #881914)

 -- Hubert Chathi <uhoreg@debian.org>  Sun, 19 Nov 2017 17:38:38 -0500

nheko (0.0+git20170715.3c1f969-2) unstable; urgency=medium

  * Add missing entries in copyright file.

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 08 Sep 2017 17:56:40 -0400

nheko (0.0+git20170715.3c1f969-1) unstable; urgency=medium

  * Initial release (Closes: #864374)

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 26 Jul 2017 21:22:29 -0400
