=== debian/changelog ===
nheko (0.4.2-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 30 May 2018 08:41:41 -0400

nheko (0.4.0-2) unstable; urgency=medium

  * debian/control: recommend installing ca-certificates

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 29 May 2018 23:08:05 -0400

nheko (0.4.0-1) unstable; urgency=medium

  * New upstream release

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 03 May 2018 14:05:36 -0400

nheko (0.3.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    * add new Build-Depends
    * require newer GCC to support C++-17
    * no longer build-depend on Boost
  * debian/patches/cmake_verbose: update patch
  * debian/patches/no_download: update patch

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 04 Apr 2018 23:13:38 -0400

nheko (0.2.1-1) unstable; urgency=medium

  * New upstream release.
    * debian/patches/cmake_verbose: update patch
    * debian/patches/no_download: update patch
    * debian/patches/no_rpath: don't let cmake set the rpath

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 28 Mar 2018 23:19:25 -0400

nheko (0.1.0-1) unstable; urgency=medium

  * New upstream release.
    * debian/control: add new Build-Depends
    * debian/copyright: add copyright info for libs/matrix-structs
    * debian/patches/series: no_march not needed any more
    * debian/patches/cmake_verbose: update patch
    * debian/patches/no_download: don't try to download dependencies

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 28 Dec 2017 16:54:20 -0500
