=== debian/control ===
Source: nheko
Section: net
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>
Build-Depends: debhelper (>=9)
 , g++ (>= 4:7)
 , cmake (>= 3.1)
 , qtbase5-dev (>= 5.7)
 , ninja-build
 , qttools5-dev
 , dh-exec
 , liblmdb++-dev
 , qtmultimedia5-dev
 , nlohmann-json3-dev
 , libtweeny-dev
 , libqt5svg5-dev
Standards-Version: 3.9.8
Homepage: https://github.com/mujx/nheko
Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
Vcs-Browser: https://salsa.debian.org/matrix-team/nheko

Package: nheko
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Description: desktop IM client for the Matrix protocol
 Nheko is a Qt-based chat client for Matrix, an open, federated communications
 protocol.  The motivation behind the project is to provide a native desktop
 app for Matrix that feels more like a mainstream chat app and less like an IRC
 client.
