=== debian/rules ===
--- 
+++ 
@@ -19,3 +19,8 @@
 
 override_dh_auto_test:
 	#
+
+make-orig-source: VERSION = `dpkg-parsechangelog | grep ^Version | sed 's/Version: \(.*\)-[^-]*/\1/'`
+make-orig-source:
+	tar czf ../nheko_$(VERSION).orig.tar.gz --exclude-vcs --exclude-backups --exclude /debian --exclude /third-party -C .. `basename $(CURDIR)`
+	tar czf ../nheko_$(VERSION).orig-third-party.tar.gz --exclude-vcs --exclude-backups third-party
